#ifndef BASEEMBEDDINGPROCESSOR_H
#define BASEEMBEDDINGPROCESSOR_H

#include <kyai-business-framework/rpc/embedding/embeddingtask.h>

#include <vector>

class BaseEmbeddingProcessorPrivate;

namespace scene {
class BaseEmbeddingProcessor {
public:
    BaseEmbeddingProcessor();
    virtual ~BaseEmbeddingProcessor();

    bool init();
    bool inited();

    TaskID addTask(const std::string& data, EmbeddingDataType dataType, TaskPriority priority = TaskPriority::MEDIUM);

    std::vector<float> getResult(const TaskID& taskId);

    std::string getModelInfo();

protected:
    virtual bool initializeResources() = 0;
    virtual std::vector<float> embedding(const EmbeddingTask& task) = 0;
    virtual std::string modelInfo() = 0;

private:
    BaseEmbeddingProcessorPrivate* d_;
};
}  // namespace scene

#endif  // BASEEMBEDDINGPROCESSOR_H
