#ifndef IMAGEEMBEDDINGPROCESSOR_H
#define IMAGEEMBEDDINGPROCESSOR_H

#include <kyai-business-framework/rpc/embedding/baseembeddingprocessor.h>

namespace scene {
class ImageEmbeddingProxy;
class ImageEmbeddingProcessor : public BaseEmbeddingProcessor {
public:
    static ImageEmbeddingProcessor& getInstance() {
        static ImageEmbeddingProcessor processor;
        return processor;
    }

    ~ImageEmbeddingProcessor();

protected:
    virtual bool initializeResources() override;
    virtual std::vector<float> embedding(const EmbeddingTask& task) override;
    virtual std::string modelInfo() override;

private:
    ImageEmbeddingProcessor() = default;

    ImageEmbeddingProxy* proxy_ = nullptr;
};
}  // namespace scene

#endif  // IMAGEEMBEDDINGPROCESSOR_H
